<?php

namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *;
     * @var array
     */
    protected $commands = [
        Commands\Inspire::class,
        Commands\Test::class,
        Commands\SmartPush\KeepContinueReadV2::class,
        Commands\GZH\FansStat::class,
        Commands\GZH\ForceUserProperty::class,
        Commands\Wechat\AdReport::class,
        Commands\Wechat\AdReportTest::class,
        Commands\Wechat\GdtAdReport::class,
        Commands\Wechat\ReportRetry::class,
        Commands\SmartPush\remindSign::class,
        Commands\Recommend\UpdateHighQualityBooks::class,
        Commands\SmartPush\ForceSubscribeDelayMsg::class,
        Commands\SmartPush\CouponExpirePush::class,
        Commands\BatchWechatMaterial\SyncWechatMaterialStatistics::class,
        //更新推送
        Commands\SmartPush\BookUpdatePush::class,

        // 微信素材批量发送
        Commands\BatchWechatMaterial\SendCustomWechatMaterial::class,
        // 删除微信素材消息
        Commands\ActionTrigger\BatchWechatMaterial\DelWechatMaterial::class,
        // 预览微信素材消息
        Commands\ActionTrigger\BatchWechatMaterial\PreviewWechatMaterial::class,
        // 同步微信素材消息
        Commands\ActionTrigger\BatchWechatMaterial\SyncZsWechatMaterial::class,
        // 测试微信素材
        Commands\ActionTrigger\BatchWechatMaterial\testWechatMaterial::class,
        //　测试微信群发
        Commands\ActionTrigger\BatchWechatMaterial\testWechatMaterialMsgSend::class,
        Commands\Wechat\RepeatReport::class,

        
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {

        $schedule->command('SmartPush:KeepContinueReadV2')->cron('06 7-23 * * *');

        //拉取公众号后台粉丝数据
        $schedule->command('gzh:fansStat')->dailyAt('09:04');

        //拉取公众号后台昵称
        //$schedule->command('gzh:force_user_property')->everyFiveMinutes();

        //微信广告上报
        $schedule->command('Wechat:WeixinAdReport')->everyFiveMinutes();
        //微信gdt上报
        $schedule->command('Wechat:GdtAdReport --type=order')->everyFiveMinutes();
        $schedule->command('Wechat:GdtAdReport --type=register')->everyFiveMinutes();
        //补传
        $schedule->command('Wechat:RepeatReport')->everyMinute();

        //$schedule->command('Wechat:ReportRetry')->hourly();

        //未签到提醒
        $schedule->command('SmartPush:remindSign --start=0 --end=7000000')->dailyAt('08:01');


        $schedule->command('UpdateHighQualityBooks')->hourly();
        //优惠券过期提醒
        $schedule->command('SmartPush:CouponExpirePush')->hourly();

        //$schedule->command('SmartPush:ForceSubscribeDelayMsg')->everyFiveMinutes();
        $schedule->command('SmartPush:ForceSubscribeDelayMsg')->cron('*/2 * * * *');

        //微信批量素材
        $schedule->command('BatchWechatMaterial:SendCustomWechatMaterial')->everyFiveMinutes();

        //更新推送
        //$schedule->command('SmartPush:BookUpdatePush')->cron('*/6 * * * *');
    }
}
