<?php


function GetIP(){ 
    if (getenv("HTTP_CLIENT_IP") && strcasecmp(getenv("HTTP_CLIENT_IP"), "unknown")) 
        $ip = getenv("HTTP_CLIENT_IP"); 
    else if (getenv("HTTP_X_FORWARDED_FOR") && strcasecmp(getenv("HTTP_X_FORWARDED_FOR"), "unknown")) 
        $ip = getenv("HTTP_X_FORWARDED_FOR"); 
    else if (getenv("REMOTE_ADDR") && strcasecmp(getenv("REMOTE_ADDR"), "unknown")) 
        $ip = getenv("REMOTE_ADDR"); 
    else if (isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], "unknown")) 
        $ip = $_SERVER['REMOTE_ADDR']; 
    else 
        $ip = "unknown"; 
    return($ip); 
}

/**
 * 转义
 */
function mysql_escape_fun($params) {
	if(is_array($params)) {
		foreach($params as $key=>$param) {
			$params[$key] = addslashes($param);
		}
		
		return $params;
	}else{
		return addslashes($params);
	}
}  

/**
 * 得到key小写的数组
 */
function get_lower_key_arr($params) {
	$data = array();
	if(is_array($params)) {
		foreach($params as $key=>$param) {
			$data[strtolower($key)] = $param;
		}
		
		return $data;
	}else{
		return strtolower($params);
	}
}   
 
function url_redirect($url){
	header("Location:".$url);
    exit;
}  

/**
 * 判断是否json数据，json_decode出来的是对象
 */
function is_not_json($str){ 
    return is_null(json_decode($str));
}
	
function get_no_empty_array($params) {
	foreach($params as $key=>$val){
		if(empty($val)) {
			unset($params[$key]);
		}
	}
	return $params;
}

function arrayToObject($e){
    if( gettype($e)!='array' ) return;
    foreach($e as $k=>$v){
        if( gettype($v)=='array' || getType($v)=='object' )
            $e[$k]=(object)arrayToObject($v);
    }
    return (object)$e;
}
 
function objectToArray($e){
    $e=(array)$e;
    foreach($e as $k=>$v){
        if( gettype($v)=='resource' ) return;
        if( gettype($v)=='object' || gettype($v)=='array' )
            $e[$k]=(array)objectToArray($v);
    }
    return $e;
}

/**
 * XML转数组
 * @param string $xmlstring XML字符串
 * @return array XML数组
 */
function simplest_xml_to_array($xmlstring) {
    return json_decode(json_encode((array) simplexml_load_string($xmlstring)), true);
}

/**
 * 数组转XML
 * @param string $arr 数组
 * @return array XML
 */
function array_to_xml($arr,$root_name='callbackSimpleReq',$dom=0,$item=0){
    if (!$dom){
        $dom = new DOMDocument("1.0");
    }
    if(!$item){
        $item = $dom->createElement($root_name); 
        $dom->appendChild($item);
    }
    foreach ($arr as $key=>$val){
        $itemx = $dom->createElement(is_string($key)?$key:"item");
        $item->appendChild($itemx);
        if (!is_array($val)){
            $text = $dom->createTextNode($val);
            $itemx->appendChild($text);
            
        }else {
            arrtoxml($val,$dom,$itemx);
        }
    }
    return $dom->saveXML();
}

/**
 *  在查询数据库时 构造 field_name IN ('value1','value2')
 *  $field_name 字段名 
 *  $value_list 值 array 或者是 逗号分隔的字符串 
 */
function db_create_in($field_name = '',$value_list )
{
    if (empty($value_list))
    {
        return $field_name . " IN ('') ";
    }
    else
    {
        if (!is_array($value_list))
        {
            $value_list = explode(',', $value_list);
        }
        $value_list = array_unique($value_list); // 去除重复数值 
        $value_list_tmp = '';
        foreach ($value_list AS $item)
        {
            $item = trim($item);
            if ($item !== '')
            {   
            	if( $item[0] =="'"){
            		$value_list_tmp .= $value_list_tmp ? ",$item" : "$item";  // in 的第一个 值 不需要逗号
            	}else{
            		$value_list_tmp .= $value_list_tmp ? ",'$item'" : "'$item'";  // in 的第一个 值 不需要逗号
            	}
            }
        }
        if (empty($value_list_tmp))
        {
            return $field_name . " IN ('') ";
        }
        else
        {
            return $field_name . ' IN (' . $value_list_tmp . ') ';
        }
    }
}

function http_get($url,$log=0) {

	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, $url);

	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,3);//成功连接服务器前等待
	curl_setopt($ch, CURLOPT_TIMEOUT,4);//成功连接服务器前等待

	curl_setopt($ch, CURLOPT_POST, 0);

	curl_setopt($ch, CURLOPT_HEADER, 0 );

	curl_setopt($ch, CURLOPT_RETURNTRANSFER , 1);//不直接输出，返回到变量
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	$curl_result = curl_exec($ch);
	if($log){
		$rinfo=curl_getinfo($ch);
		v('http_get_info:');v($rinfo) ;
	}
//	v($curl_result);

    curl_close($ch);
	return $curl_result;
}

function http_post($url, $para,$redirect = 0,$log=0) {
	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, $url);

	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,3);//成功连接服务器前等待
	curl_setopt($ch, CURLOPT_TIMEOUT,4);//成功连接服务器前等待

	curl_setopt($ch, CURLOPT_POST, 1);

	curl_setopt($ch, CURLOPT_HEADER, 0 );

	curl_setopt($ch, CURLOPT_POSTFIELDS , $para);// post传输数据

	curl_setopt($ch, CURLOPT_RETURNTRANSFER , 1);//不直接输出，返回到变量
	if($redirect) {
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	}

	$curl_result = curl_exec($ch);

	
	if($log) {
	   v($curl_result);
	   $rinfo=curl_getinfo($ch);  
	   v($rinfo) ;
	}
    curl_close($ch);
	return $curl_result;
}

function hpost($url, $para,$to_array=true) {
	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, $url);

    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,3);//成功连接服务器前等待
	curl_setopt($ch, CURLOPT_TIMEOUT,4);//成功连接服务器前等待

	curl_setopt($ch, CURLOPT_POST, 1);

	curl_setopt($ch, CURLOPT_HEADER, 0 );

	curl_setopt($ch, CURLOPT_POSTFIELDS , $para);// post传输数据

	curl_setopt($ch, CURLOPT_RETURNTRANSFER , 1);//不直接输出，返回到变量
// 	if($redirect) {
// 		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
// 	}

	$curl_result = curl_exec($ch);
// 	$rinfo=curl_getinfo($ch);
// 	v($rinfo) ;


	if($to_array){
// 		v('curl_result:'.json_encode($para));
// 		v($curl_result);
		$curl_result = json_decode($curl_result);
		$curl_result = objectToArray($curl_result);
	}
    curl_close($ch);
	return $curl_result;
}


function json_echo($result){
	echo json_encode($result,JSON_UNESCAPED_UNICODE);exit();
}

/**
 * 根据当前时间获取订单号
 */
function get_orderno_by_time(){
	// 毫秒 用microtime能输出当前的秒的后面8位小数 乘以1000取整数就行了
	$ms = floor(microtime()*1000)%1000;
	$ms = sprintf("%03d", $ms);
	$order_no = date('YmdHis').$ms.rand(1000,9999);
	return $order_no;
}

/**
 获取某目录下所有文件、目录名（不包括子目录下文件、目录名）
 */
function get_dir_files($dir){
	$files = array();
	
	$handler = opendir($dir);
	while (($filename = readdir($handler)) !== false) {//务必使用!==，防止目录下出现类似文件名“0”等情况
		if ($filename != "." && $filename != "..") {
			$files[] = $filename ;
		}
	}
	closedir($handler);
	return $files;
}

/**
 * 通过图片的远程img_url，下载到本地
 * @param: $img_url为图片远程链接
 * @param: $img_save_path为下载图片后保存的路径
 */
function DownImage($img_url,$img_save_path) {
	if(empty($img_url)) return false;
	@unlink($img_save_path);
	ob_start();
	readfile($img_url);
	$img = ob_get_contents();
	ob_end_clean();
	$size = strlen($img);
	//"../../images/books/"为存储目录，$filename为文件名
	$fp=@fopen($img_save_path, "a");
	fwrite($fp,$img);
	fclose($fp);
	return $img_save_path;
}

/**
 * 生成表里的uuid
 */
function get_uuid(){
	if (PHP_OS == "Linux") {
		if (function_exists('uuid_create')) {
			//Linux server & 开启uuid扩展
			// $uuid = uuid_create(1);
		}
		$uuid = trim(shell_exec("cat /proc/sys/kernel/random/uuid"));
	
	} else {
		//Windows server | Linux server & 未开启uuid扩展
		$str = md5(uniqid(mt_rand()));
		$uuid = '';
		$uuid .= substr($str, 0, 8) . '-';
		$uuid .= substr($str, 8, 4) . '-';
		$uuid .= substr($str, 12, 4) . '-';
		$uuid .= substr($str, 16, 4) . '-';
		$uuid .= substr($str, 20, 12);
	}
	return $uuid;
}

?>