<?php

return [
    /*
     * Debug 模式，bool 值：true/false
     *
     * 当值为 false 时，所有的日志都不会记录
     */
    'debug'  => true,
    /*
     * 账号基本信息，请从微信公众平台/开放平台获取
     * 为了方便多台服务器管理，放redis是最好的，文件缓存有同步的设置问题，还有微信ticket回调的ip指定问题
     */
    'app_id'  => env('WECHAT_OP_APPID', ''),         // AppID
    'secret'  => env('WECHAT_OP_SECRET', ''),     // AppSecret
    'token'   => env('WECHAT_OP_TOKEN', ''),          // Token
    'aes_key' => env('WECHAT_OP_AES_KEY', ''),                    // EncodingAESKey
    'cache'   => [
        'driver' => 'redis',    // redis, filesystem, laravel
        'dir' => storage_path('tmp') // 只有为filesystem时候这个目录才有效
    ],
    
    /*
     * 日志配置
     *
     * level: 日志级别，可选为：
     *                 debug/info/notice/warning/error/critical/alert/emergency
     * file：日志文件位置(绝对路径!!!)，要求可写权限
     */
    'log' => [
        'level' => env('WECHAT_OP_LOG_LEVEL', 'debug'),
        'file'  => env('WECHAT_OP_LOG_FILE', storage_path('logs/wechat_op_'.date('Y-m-d').'.log')),
    ]
];